#ifdef MSS
#include <mss.h>
#endif


#include <stdio.h>
#include <stdlib.h>

#include "vb_types.h"
#include "vb_set.h"

#define CL_DISP		"-display"
#define CL_DISP_320	"320"
#define CL_DISP_640	"640"
#define CL_DISP_800	"800"
#define CL_DISP_1024	"1024"
#define CL_DISP_640v2	"640v2"
#define CL_DISP_800v2	"800v2"
#define CL_DISP_1024v2	"1024v2"

#define CL_DSPMODE	"-dspmode"
#define CL_DSPMODE_NORM	"normal"
#define CL_DSPMODE_R_B	"red_blue"
#define CL_DSPMODE_INT	"interlace"
#define CL_DSPMODE_OV	"over_under"
#define CL_DSPMODE_SS	"side"
#define CL_DSPMODE_CSCOPE "cscope"

#define CL_FRMSKP		"-frmskp" 

#define CL_PALLET		"-pallet"
#define CL_PALLET_NORM	"normal"
#define CL_PALLET_RED	"red"
#define CL_PALLET_RB	"rb"
#define CL_PALLET_RG	"rg"
#define CL_PALLET_RBG	"rbg"

#define CL_BRTNES		"-brite"
#define CL_FLIP		"-flip"
#define CL_DEBUG		"-debug"

#define CL_HELP1		"-?"
#define CL_HELP2		"-help"


VB_OPT         tVBOpt;


void setOptions(int argc, char *argv[]) {
   int tmp=-1;
   char buf[256];
   int done = 0;
   int vIndex = 2;
   
   //Set up the Defaults
   tVBOpt.FRMSKIP = 0;
   tVBOpt.DSPMODE = dm_NORMAL;
   tVBOpt.DSPSWAP = 0;
   tVBOpt.PALMODE = pal_NORMAL;
   tVBOpt.DEBUG   = 0;
   tVBOpt.BFACTOR = 64;
   tVBOpt.SCR_X   = 640;
   tVBOpt.SCR_Y   = 480;
   tVBOpt.SCR_MODE = d_VESA1; //Vesa1

   if ((argc < 2)||(stricmp(argv[1], CL_HELP1) == 0)||(stricmp(argv[1], CL_HELP2) == 0)) {
      printf(" Usage: vb_98 <rom_name.vb> [-options]\n");
      printf(" Options: \n");
      printf("  -display (320, 640, 640v2, 800, 800v2, 1024, 1024v2) \n");
      printf("  -dspmode (normal, red_blue, interlace, over_under, side, cscope)\n");
      printf("  -frmskp (0-9)\n");
      printf("  -pallet (normal, red, rb, rg, rbg)\n");
      printf("  -brite (0-127)\n");
      printf("  -flip\n");
      printf("  -debug\n");
      exit(0); //Does this work?
   }

   tVBOpt.PROG_NAME = argv[0];
   tVBOpt.ROM_NAME  = argv[1];

   while(!done) {
      if (stricmp(argv[vIndex], CL_DISP) == 0) {
         if (stricmp(argv[vIndex+1], CL_DISP_320) == 0) {
            tVBOpt.SCR_MODE = d_VGA; //VGA
            tVBOpt.SCR_X   = 320;
            tVBOpt.SCR_Y   = 200;
         } else if (stricmp(argv[vIndex+1], CL_DISP_640) == 0) {
            tVBOpt.SCR_MODE = d_VESA1; //Vesa1
            tVBOpt.SCR_X   = 640;
            tVBOpt.SCR_Y   = 480;
         } else if (stricmp(argv[vIndex+1], CL_DISP_640v2) == 0) {
            tVBOpt.SCR_MODE = d_VESA2; //Vesa2
            tVBOpt.SCR_X   = 640;
            tVBOpt.SCR_Y   = 480;
         } else if (stricmp(argv[vIndex+1], CL_DISP_800) == 0) {
            tVBOpt.SCR_MODE = d_VESA1; //Vesa1
            tVBOpt.SCR_X   = 800;
            tVBOpt.SCR_Y   = 600;
         } else if (stricmp(argv[vIndex+1], CL_DISP_800v2) == 0) {
            tVBOpt.SCR_MODE = d_VESA2; //Vesa2
            tVBOpt.SCR_X   = 800;
            tVBOpt.SCR_Y   = 600;
         } else if (stricmp(argv[vIndex+1], CL_DISP_1024) == 0) {
            tVBOpt.SCR_MODE = d_VESA1; //Vesa1
            tVBOpt.SCR_X   = 1024;
            tVBOpt.SCR_Y   = 768;
         } else if (stricmp(argv[vIndex+1], CL_DISP_1024v2) == 0) {
            tVBOpt.SCR_MODE = d_VESA2; //Vesa2
            tVBOpt.SCR_X   = 1024;
            tVBOpt.SCR_Y   = 768;
         }
         vIndex+=2;
      }else if (stricmp(argv[vIndex], CL_DSPMODE) == 0){
         if (stricmp(argv[vIndex+1], CL_DSPMODE_NORM) == 0) {
            tVBOpt.DSPMODE = dm_NORMAL;
         } else if (stricmp(argv[vIndex+1], CL_DSPMODE_R_B) == 0) {
            tVBOpt.DSPMODE = dm_RedBlue;
         } else if (stricmp(argv[vIndex+1], CL_DSPMODE_INT) == 0) {
            tVBOpt.DSPMODE = dm_INTERLACED;
         } else if (stricmp(argv[vIndex+1], CL_DSPMODE_OV) == 0) {
            tVBOpt.DSPMODE = dm_OVRUNDR;
         } else if (stricmp(argv[vIndex+1], CL_DSPMODE_SS) == 0) {
            tVBOpt.DSPMODE = dm_SIDESIDE;
         } else if (stricmp(argv[vIndex+1], CL_DSPMODE_CSCOPE) == 0) {
            tVBOpt.DSPMODE = dm_CYBERSCOPE;
         }
         vIndex+=2;
      }else if (stricmp(argv[vIndex], CL_PALLET) == 0){
         if (stricmp(argv[vIndex+1], CL_PALLET_NORM) == 0) {
            tVBOpt.PALMODE = pal_NORMAL;
         } else if (stricmp(argv[vIndex+1], CL_PALLET_RED) == 0) {
            tVBOpt.PALMODE = pal_RED;
         } else if (stricmp(argv[vIndex+1], CL_PALLET_RB) == 0) {
            tVBOpt.PALMODE = pal_RB;
         } else if (stricmp(argv[vIndex+1], CL_PALLET_RG) == 0) {
            tVBOpt.PALMODE = pal_RG;
         } else if (stricmp(argv[vIndex+1], CL_PALLET_RBG) == 0) {
            tVBOpt.PALMODE = pal_RBG;
         }
         vIndex+=2;

      }else if (stricmp(argv[vIndex], CL_FRMSKP) == 0){
         tmp=atoi(argv[vIndex+1]);
	   if((tmp>=0)&&(tmp<=9)) tVBOpt.FRMSKIP = tmp;
         vIndex+=2;
      }else if (stricmp(argv[vIndex], CL_BRTNES) == 0){
         tmp=atoi(argv[vIndex+1]);
	   if((tmp>=0)&&(tmp<=127)) tVBOpt.BFACTOR = tmp;
         vIndex+=2;

      }else if (stricmp(argv[vIndex], CL_FLIP) == 0){
         tVBOpt.DSPSWAP = 1;
         vIndex++;
      }else if (stricmp(argv[vIndex], CL_DEBUG) == 0){
         tVBOpt.DEBUG = 1;
         vIndex++;
      } else {
         vIndex++;
      }
      if(vIndex >= argc) done = 1;
   }
}
